function varargout = ListBox(varargin)
% LISTBOX M-file for ListBox.fig
%      LISTBOX, by itself, creates a new LISTBOX or raises the existing
%      singleton*.
%
%      H = LISTBOX returns the handle to a new LISTBOX or the handle to
%      the existing singleton*.
%
%      LISTBOX('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LISTBOX.M with the given input arguments.
%
%      LISTBOX('Property','Value',...) creates a new LISTBOX or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before ListBox_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to ListBox_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help ListBox

% Last Modified by GUIDE v2.5 18-Apr-2005 18:18:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ListBox_OpeningFcn, ...
                   'gui_OutputFcn',  @ListBox_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ListBox is made visible.
function ListBox_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to ListBox (see VARARGIN)

% Choose default command line output for ListBox
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% Populate the listbox
update_listbox(handles)
set(handles.listbox1,'Value',[])

% Make the GUI modal
set(handles.figure1,'WindowStyle','modal')

% UIWAIT makes ListBox wait for user response (see UIRESUME)
 uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = ListBox_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

delete(handles.figure1);


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

%Ensure only one item is selected
workvar=evalin('base','who');
if length(workvar)==0
    errordlg('No variables to select from','Workspace!','modal');
else 
    NumSelItems=get(handles.listbox1,'Value');
    if length(NumSelItems)>1 
        errordlg('Please select only one variable','Input Argument Error!','modal');; 
    else
        variables=get(hObject,'String');
        handles.output = variables{NumSelItems(1)}; 
        %update handles structure
        guidata(hObject,handles);
    end;
end;

% --- Executes on button press in SelectButton.
function SelectButton_Callback(hObject, eventdata, handles)
% hObject    handle to SelectButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

NumSelItems=get(handles.listbox1,'Value');
 if length(NumSelItems)~=1
     errordlg('No variables selected, please select one variable','Import error','modal');
 else
    % Use UIRESUME instead of delete because the OutputFcn needs
    % to get the updated handles structure.
    uiresume(handles.figure1);
 end

% --- Executes on button press in CancelButton.
function CancelButton_Callback(hObject, eventdata, handles)
% hObject    handle to CancelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.output='-1';
guidata(hObject,handles);

uiresume(handles.figure1);

% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    handles.output='-1';
    guidata(hObject,handles);
    uiresume(handles.figure1);
    
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Sub-functions%%%%%%%%%%%%%%%%%%%%%%%%

function update_listbox(handles)
% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1

% Updates the listbox to match the current workspace
vars = evalin('base','who');
set(handles.listbox1,'String',vars)




