function varargout = multilevsig(varargin)
% MULTILEVSIG M-file for multilevsig.fig
%      MULTILEVSIG, by itself, creates a new MULTILEVSIG or raises the existing
%      singleton*.
%
%      H = MULTILEVSIG returns the handle to a new MULTILEVSIG or the handle to
%      the existing singleton*.
%
%      MULTILEVSIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MULTILEVSIG.M with the given input arguments.
%
%      MULTILEVSIG('Property','Value',...) creates a new MULTILEVSIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before multilevsig_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to multilevsig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help multilevsig

% Last Modified by GUIDE v2.5 21-Jul-2005 13:59:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @multilevsig_OpeningFcn, ...
                   'gui_OutputFcn',  @multilevsig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before multilevsig is made visible.
function multilevsig_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to multilevsig (see VARARGIN)

% Choose default command line output for multilevsig
handles.output = hObject;

%Initialising the arguments
handles.SignalLength=0; %Initialising signal length = 0
handles.SignalLevel=0; %Initialising signal level = 0
global Harmv;
Harmv=0; %Initialising signal harmonics = 0
handles.HarmonicsSupp=[];%Initialising suppressed harmonics = null
handles.Amplitude=0;%Initialising amplitudes = 0
handles.ZOH_effect=1;%initialisng ZOH = 1
handles.Quantisation=[1:0.1:4];%Initialising quantisation
handles.iteration=100;%Initialising number of iterations = 100



%Other variables
handles.name=get(handles.SignalName,'String'); %Get the string name for the signal
handles.NumberHarmonics=0;%Number of specified Harmonics

%Flags
handles.verified(1:4)=[0,0,1,1]; %Flag to indicate that the aruments are verified 0-invalid 1-valid
handles.Designed=0; %Flag to indicate sinal is designed 0-undesigned 1-designed

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes multilevsig wait for user response (see UIRESUME)
%uiwait(handles.Multifig);


% --- Outputs from this function are returned to the command line.
function varargout = multilevsig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure

varargout{1} = handles.output;


% --- Executes on button press in radiobutton_2.
function radiobutton_2_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_2
if get(hObject,'Value')==1
    handles.SignalLevel=2; %set the number of signal levels
    guidata(hObject,handles);
else
    handles.SignalLevel=0;
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.radiobutton_3,'Value',0);
set(handles.radiobutton_5,'Value',0);
set(handles.radiobutton_7,'Value',0);

%Check for binary if 2,3 or 2, 5 are selected to suppress
if get(handles.Harmbutton_23,'Value')==1|get(handles.Harmbutton_25,'Value')==1
    errordlg('Signal must be more than 2 levels to suppress multiples of 2,3 or 2,5','Input Argument Error!','modal');
    handles.SignalLevel=0;
    guidata(hObject,handles);
    set(hObject,'Value',0);
end



% --- Executes on button press in radiobutton_3.
function radiobutton_3_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_3

if get(hObject,'Value')==1
    handles.SignalLevel=3; %set the number of signal levels
    guidata(hObject,handles);
else
    handles.SignalLevel=0; 
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.radiobutton_2,'Value',0);
set(handles.radiobutton_5,'Value',0);
set(handles.radiobutton_7,'Value',0);

% --- Executes on button press in radiobutton_5.
function radiobutton_5_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_5

if get(hObject,'Value')==1
    handles.SignalLevel=5; %set the number of signal levels
    guidata(hObject,handles);
else
    handles.SignalLevel=0;
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.radiobutton_2,'Value',0);
set(handles.radiobutton_3,'Value',0);
set(handles.radiobutton_7,'Value',0);

% --- Executes on button press in radiobutton_7.
function radiobutton_7_Callback(hObject, eventdata, handles)
% hObject    handle to radiobutton_7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobutton_7

if get(hObject,'Value')==1
    handles.SignalLevel=7; %set the number of signal levels
    guidata(hObject,handles);
else
    handles.SignalLevel=0;
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.radiobutton_2,'Value',0);
set(handles.radiobutton_3,'Value',0);
set(handles.radiobutton_5,'Value',0);

% --- Executes on button press in Harmbutton_2.
function Harmbutton_2_Callback(hObject, eventdata, handles)
% hObject    handle to Harmbutton_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Harmbutton_2
if get(hObject,'Value')==1
    handles.HarmonicsSupp=[2]; %set the number of suppressed harmonics
                               %to multiples of 2
    guidata(hObject,handles);
    %Call NuHarm function to generate harmonic sequence
    if strcmp(get(handles.NuHarm,'String'),'')==0
        NuHarm_Callback(handles.NuHarm, eventdata, handles);
    end
    if strcmp(get(handles.SigLen,'String'),'')==0
        SigLen_Callback(handles.SigLen, eventdata, handles); %Call Siglen to check if it is a period
    end
else
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.Harmbutton_0,'Value',0);
set(handles.Harmbutton_23,'Value',0);
set(handles.Harmbutton_25,'Value',0);


% --- Executes on button press in Harmbutton_23.
function Harmbutton_23_Callback(hObject, eventdata, handles)
% hObject    handle to Harmbutton_23 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Harmbutton_23
if get(hObject,'Value')==1
    handles.HarmonicsSupp=[2,3]; %set the number of suppressed harmonics
                             %to multiples of 2 and 3
    guidata(hObject,handles);
    %Call NuHarm function to generate harmonic sequence
    if strcmp(get(handles.NuHarm,'String'),'')==0
        NuHarm_Callback(handles.NuHarm, eventdata, handles)
    end
    if strcmp(get(handles.SigLen,'String'),'')==0
        SigLen_Callback(handles.SigLen, eventdata, handles) %Call Siglen to check if it is a period
    end                        
else
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.Harmbutton_0,'Value',0);
set(handles.Harmbutton_2,'Value',0);
set(handles.Harmbutton_25,'Value',0);

%Check if signal is binary, which is not possible for 2,3 suppression
if get(handles.radiobutton_2,'Value')==1
    errordlg('Signal must be more than 2 levels to suppress multiples of 2 and 3','Input Argument Error!','modal');
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
    set(hObject,'Value',0);
end

% --- Executes on button press in Harmbutton_25.
function Harmbutton_25_Callback(hObject, eventdata, handles)
% hObject    handle to Harmbutton_25 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Harmbutton_25
if get(hObject,'Value')==1
    handles.HarmonicsSupp=[2,5]; %set the number of suppressed harmonics to
                               %multiples of 2,3 and 5 suppressed
    guidata(hObject,handles);
    %Call NuHarm function to generate harmonic sequence
    if strcmp(get(handles.NuHarm,'String'),'')==0
        NuHarm_Callback(handles.NuHarm, eventdata, handles)
    end
    if strcmp(get(handles.SigLen,'String'),'')==0
        SigLen_Callback(handles.SigLen, eventdata, handles) %Call Siglen to check if it is a period 
    end
else
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.Harmbutton_0,'Value',0);
set(handles.Harmbutton_2,'Value',0);
set(handles.Harmbutton_23,'Value',0);

%Check if signal is binary, which is not possible for 2,5 suppression
if get(handles.radiobutton_2,'Value')==1
    errordlg('Signal must be more than 2 levels to suppress multiples of 2 and 5','Input Argument Error!','modal');
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
    set(hObject,'Value',0);
end

% --- Executes on button press in Harmbutton_0.
function Harmbutton_0_Callback(hObject, eventdata, handles)
% hObject    handle to Harmbutton_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of Harmbutton_0
if get(hObject,'Value')==1
    handles.HarmonicsSupp=[0]; %set the number of suppressed to none
    guidata(hObject,handles);
    if strcmp(get(handles.NuHarm,'String'),'')==0
        NuHarm_Callback(handles.NuHarm, eventdata, handles) %Call NuHarm function to generate harmonic sequence
    end
    if strcmp(get(handles.SigLen,'String'),'')==0
        SigLen_Callback(handles.SigLen, eventdata, handles) %Call Siglen to check if it is a period
    end
else
    handles.HarmonicsSupp=[];
    guidata(hObject,handles);
end

%Set the the other radio buttons to zero
set(handles.Harmbutton_2,'Value',0);
set(handles.Harmbutton_23,'Value',0);
set(handles.Harmbutton_25,'Value',0);

function NuHarm_Callback(hObject, eventdata, handles)
% hObject    handle to NuHarm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NuHarm as text
%        str2double(get(hObject,'String')) returns contents of NuHarm as a double

global Harmv;
%Initialise harmonic vector to be zero
Harmv=0;

Nu= str2double(get(hObject,'String'));
handles.verified(1)=0; %Set flag indicating input needs validating
guidata(hObject,handles);

if (Nu<=0 | mod(Nu,1)~=0)
    errordlg('Please enter a positive integer','Invalid Input','modal');
    set(hObject,'BackgroundColor','r')
    handles.Harmonic=0;
    guidata(hObject,handles);
else %Generate the harmonic vector
    set(hObject,'BackgroundColor','w')
    handles.NumberHarmonics=Nu;
    guidata(hObject,handles);

    %Intialise variable to 0
    harmonic_specification=0;
 
    %Configure specification
    if sum(handles.HarmonicsSupp)==0
        harmonic_specification=1;
    elseif sum(handles.HarmonicsSupp)==2
        harmonic_specification=2;
    elseif sum(handles.HarmonicsSupp)==5
        harmonic_specification=3;
    else 
        harmonic_specification=4;
    end

    %Specify number of harmonics required
    harmonic_number=Nu;

    if harmonic_specification==1
        harm=[1:Nu]; %All Harmonics
    elseif harmonic_specification==2
        harm=[1:2:2*Nu]; %Odd harmonics
    elseif harmonic_specification==3
        N=10000;
        j=0;
        for i=1:N;
            if((mod(i,2)~=0)&(mod(i,3)~=0))
                j=1+j;
                harm(j)=i; %2 and 3 supressed
                if j==harmonic_number;
                    break;
                end
            end
        end
    elseif harmonic_specification==4
        N=10000;
        j=0;
        for i=1:N;
            if((mod(i,2)~=0)&(mod(i,5)~=0))
                j=1+j;
                harm(j)=i; %2 and 5 suppressed
                if j==harmonic_number;
                    break;
                end
            end
        end
    end                   
    Harmv=harm;
    assignin('base','Harmonics',harm);
    set(handles.HarmValue,'String',num2str(harm(Nu)));
    set(handles.HarmValue,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
    
    handles.verified(1)=1; %Set flag indicating valid input
    guidata(hObject,handles);
    
    %Call Amplitude function to update their amplitudes
    if get(handles.AmplitudeUniform,'Value')==1
        %AmplitudeUniform_Callback(handles.AmplitudeUniform,eventdata,handles);
        handles.Amplitude=ones(size(Harmv));
        guidata(hObject,handles);
    elseif get(handles.AmplitudeImport,'Value')==1
        if length(Harmv)~=length(handles.Amplitude)
            errordlg('Amplitude vector must be of equal length as Harmonic Vector','Input Argument Error!','modal')
            set(hObject,'BackgroundColor','r');
            set(handles.AmplitudeImport,'Value',0);
        end
    end
end

if strcmp(get(handles.SigLen,'String'),'')==0
    SigLen_Callback(handles.SigLen, eventdata, handles) %Call Siglen to check if highest harmonic does not exceed signal period
end


% --- Executes on button press in AmplitudeUniform.
function AmplitudeUniform_Callback(hObject, eventdata, handles)
% hObject    handle to AmplitudeUniform (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AmplitudeUniform
global Harmv
%Set the the other radio buttons to zero
set(handles.AmplitudeImport,'Value',0);
if get(hObject,'Value')==1
    handles.Amplitude=ones(size(Harmv));
    guidata(hObject,handles);
    set(handles.NuHarm,'BackgroundColor','w');
    set(handles.AmpName,'String','');
    set(handles.AmpLength,'String','');
    set(handles.AmpLength,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
    set(handles.AmpName,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
if get(hObject,'Value')==0
    handles.Amplitude=0;
    guidata(hObject,handles);
end

% --- Executes on button press in AmplitudeImport.
function AmplitudeImport_Callback(hObject, eventdata, handles)
% hObject    handle to AmplitudeImport (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of AmplitudeImport
global Harmv
tempAmp=0;
%Set the the other radio buttons to zero
set(handles.AmplitudeUniform,'Value',0);
if get(hObject,'Value')==1 
    
    if sum(handles.Amplitude)~=0
        tempAmp=handles.Amplitude; %Temporary variable to store the previous value    
    end
    
    Ampv=ListBox('Title','Import from Workspace',handles);
    Amp=evalin('base',Ampv);
    
    if Amp==-1 %Indiacting user has selected 'Cancel in the list box
        handles.Amplitude=tempAmp;
        guidata(hObject,handles);
        set(hObject,'Value',0);
    else %Indiacting user has selected from the list box
        verified=verify(Amp);
        if verified~=1 
            handles.Amplitude=0; 
            guidata(hObject,handles);
            set(handles.AmplitudeImport,'Value',0);
            set(handles.AmpName,'String',Ampv)
            set(handles.AmpLength,'String',num2str(length(Amp)));
            set(handles.AmpName,'BackgroundColor','r');
        elseif strcmp(get(handles.NuHarm,'String'),'')==0 %Checek if number of harmonics is specified
            if length(Harmv)~=length(Amp) %Check if lengths are same
                errordlg('Amplitude vector must be of equal length as Harmonic Vector','Input Argument Error!','modal')
                handles.Amplitude=0; 
                guidata(hObject,handles);
                set(handles.AmplitudeImport,'Value',0);
                set(handles.AmpName,'String','Invalid Input');
                set(handles.AmpLength,'String',num2str(length(Amp)));
                set(handles.AmpLength,'BackgroundColor','r');
            else %Else update amplitude vector
                tempAmp=handles.Amplitude;
                handles.Amplitude=Amp; 
                guidata(hObject,handles);
                set(handles.NuHarm,'BackgroundColor','w');
                set(handles.AmpName,'String',Ampv);
                set(handles.AmpLength,'String',num2str(length(Amp)));
                set(handles.AmpLength,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
                set(handles.AmpName,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
            end
        else %Else update amplitude vector if no number harmonics are specified
            tempAmp=handles.Amplitude;
            handles.Amplitude=Amp; 
            guidata(hObject,handles);
            set(handles.AmpName,'String',Ampv);
            set(handles.AmpLength,'String',num2str(length(Amp)));
            set(handles.AmpLength,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
            set(handles.AmpName,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
        end
    end
end
% if get(hObject,'Value')==0
%     handles.Amplitude=0;
%     guidata(hObject,handles);
% end
       

function SigLen_Callback(hObject, eventdata, handles)
% hObject    handle to SigLen (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SigLen as text
%        str2double(get(hObject,'String')) returns contents of SigLen as a double

global Harmv
N= str2double(get(hObject,'String'));
handles.verified(2)=1; %Set flag indicating to inputs needs to be validated
guidata(hObject,handles);

%Ensure input is positive integer
if (N<0 | mod(N,1)~=0)
    errordlg('Please enter a positive integer','Invalid Input','modal');
    set(hObject,'BackgroundColor','r')
    handles.verified(2)=0; %Set flag indicating to inputs needs to be validated
    guidata(hObject,handles);
elseif length(handles.HarmonicsSupp)~=0 && handles.HarmonicsSupp(1)~=0 && mod(N,prod(handles.HarmonicsSupp))~=0
    errordlg('Period must be a multiple of suppressed harmonics','Invalid Input','modal');
    set(hObject,'BackgroundColor','r');
    handles.verified(2)=0; %Set flag indicating to inputs needs to be validated
    guidata(hObject,handles);
elseif sum(Harmv)~=0 & max(Harmv)>N/2
    errordlg('Period must be at least greater than twice highest harmonic number','Invalid Input','modal');
    set(hObject,'BackgroundColor','r');
    handles.verified(2)=0; %Set flag indicating to inputs needs to be validated
    guidata(hObject,handles);
else
    set(hObject,'BackgroundColor','w')
    set(handles.HarmValue,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
    guidata(hObject,handles);
    handles.SignalLength=N;
    handles.verified(2)=1; %Set flag indicating valid input
    guidata(hObject,handles);
end


function SignalName_Callback(hObject, eventdata, handles)
% hObject    handle to SignalName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of SignalName as text
%        str2double(get(hObject,'String')) returns contents of SignalName as a double
handles.name=get(hObject,'String');
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function SignalName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SignalName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

 % --- Executes during object creation, after setting all properties.
function ZOH_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ZOH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

set(hObject,'Value',1);

% --- Executes on button press in ZOH.
function ZOH_Callback(hObject, eventdata, handles)
% hObject    handle to ZOH (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of ZOH

handles.ZOH_effect=get(hObject,'Value');
%update handles structure
guidata(hObject,handles);


function Iter_Callback(hObject, eventdata, handles)
% hObject    handle to Iter (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of Iter as text
%        str2double(get(hObject,'String')) returns contents of Iter as a double

iterations = str2double(get(hObject,'String'));
handles.verified(4)=0;%Set flag indicating to inputs needs to be validated
guidata(hObject,handles);
if (iterations<0 | mod(iterations,1)~=0)
    errordlg('Please enter a positive integer','Invalid Input','modal');
    set(hObject,'BackgroundColor','r');
else
    handles.verified(4)=1;%Set flag indicating valid input
    handles.iteration=iterations; 
    guidata(hObject,handles);
    set(hObject,'BackgroundColor','w');
end
 
 
function QPara_Callback(hObject, eventdata, handles)
% hObject    handle to QPara (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of QPara as text
%        str2double(get(hObject,'String')) returns contents of QPara as a double

handles.verified(3)=0;
guidata(hObject,handles);

%Read the quantisation parameter vector from text box
try,Q=evalin('base',get(hObject,'String'));
    set(hObject,'BackgroundColor','w');
catch,
    errordlg(lasterr,'Input Argument Error!','modal');
    set(hObject,'BackgroundColor','r');
    return,
end;

handles.verified(3)=verify(Q);
handles.Quantisation=Q;

%update handles structure
guidata(hObject,handles);


% --- Executes on button press in defaultbutton3.
function defaultbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to defaultbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

set(handles.ZOH,'Value',1);
set(handles.QPara,'String','[1:0.1:4]');
set(handles.QPara,'BackgroundColor','w');
set(handles.Iter,'String',100);
set(handles.Iter,'BackgroundColor','w');

handles.ZOH_effect=1;
handles.Quantisation=[1:0.1:4];
handles.iteration=100;
handles.verified(3:4)=[1,1];
%update handles structure
guidata(hObject,handles);


% --- Executes on button press in design.
function design_Callback(hObject, eventdata, handles)
% hObject    handle to design (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global Harmv
 handles.Designed=0; %Flag indicating the signal not still designed 
 guidata(hObject,handles); %Updata handles structure
 
 %Gets all the arguments passed by the user
 N=handles.SignalLength;
 freqv=Harmv;
 ampv=handles.Amplitude;
 no_f=handles.HarmonicsSupp;
 nolev=handles.SignalLevel;
 option=handles.ZOH_effect;
 rnst=handles.iteration;
 q=handles.Quantisation;
 
 %Call Signal Name to get the specified name for signal
 SignalName_Callback(handles.SignalName, eventdata, handles);

 %Display variable values for debugging
 %disp(nolev);disp(no_f);disp(freqv);disp(ampv);disp(N);disp(option);disp(rnst);%disp(q);
  
 AU=get(handles.AmplitudeUniform,'Value');
 AI=get(handles.AmplitudeImport,'Value');
%Rechecks if all the arguments are valid by calling all the callback
%functions again before signal design 
if prod(handles.verified)==0    
    SigLen_Callback(handles.SigLen, eventdata,handles);
    NuHarm_Callback(handles.NuHarm,eventdata,handles);
    QPara_Callback(handles.QPara, eventdata, handles)
    Iter_Callback(handles.Iter,eventdata,handles);
  
%If inputs from edit text boxes are valid check the radio button inputs
elseif length(handles.HarmonicsSupp)==0
    errordlg('Please Select a Harmonic Suppresion','Select Input','modal');
elseif sum(handles.SignalLevel)==0
    errordlg('Please Select a Signal Level','Select Input','modal');
elseif sum(handles.Amplitude)==0 |(AU==0 & AI==0)
    errordlg('Please Select Amplitude for the Harmonics','Select Input','modal');
else
    handles.Signal=multilev_new(N,freqv,ampv,no_f,nolev,option,rnst,q);
    try assignin('base',handles.name,handles.Signal); catch,
    errordlg(lasterr,'Input Argument Error!','modal'),return,end;
    SigProp(handles.Signal,handles);
    handles.Designed=1; %Flag indicating the signal is been designed 
    guidata(hObject,handles);
end

function SigProp(bitseries,handles)
%calculates PIPS
PIPS = calculate_PIPS(bitseries);

%calculates PIPSE
if mod(length(bitseries),2)==1
   freqv = 1:(length(bitseries)-1)/2;
else
   freqv = 1:2:length(bitseries)/2-2;
end
PIPSE = calculate_PIPSE(bitseries,freqv);

%calculates EMINE
if mod(length(bitseries),2)==1
   least_power = (length(bitseries)-1)/2;
   angle = pi*least_power/length(bitseries);
   for n = 1:least_power
      other_angles(n) = pi*n/length(bitseries);
      power(n) = (sin(other_angles(n))/other_angles(n))^2;
   end
   EMINE = 100*sin(angle)/angle/(sqrt(sum(power)/least_power));
else
   least_power = (length(bitseries)/2)-2;
   angle = pi*least_power/length(bitseries);
   for n = 1:2:least_power
      other_angles(n) = pi*n/length(bitseries);
      power(n) = (sin(other_angles(n))/other_angles(n))^2;
   end
   EMINE = 100*sin(angle)/angle/(sqrt(sum(power)/((least_power+1)/2)));
end
set(handles.PIPS,'String',num2str(PIPS));
set(handles.PIPSE,'String',num2str(PIPSE));
set(handles.EMINE,'String',num2str(EMINE));


% --- Executes on button press in close.
function close_Callback(hObject, eventdata, handles)
% hObject    handle to close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_response=ConfirmClose('Title','Exit Multilev');
 switch lower(user_response)
 case 'no'
 %Take no action
 case 'yes'
% Prepare to close GUI application window
    delete(handles.Multifig); %delete multilev window
 end

 % --- Executes when user attempts to close Multifig.
function Multifig_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to Multifig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
close_Callback(handles.close, eventdata, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Sub-functions%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function verified=verify(user_input);
verified=0;
%Checks if the the variable is of type double
if strcmp(class(user_input),'double')==0
   errordlg('Argument must be of type double','Input Argument Error!','modal');
   return
else %Else check if variable is a row vector of positive elements
   len=size(user_input);
   if (len(1)>1 || length(len)>2)
       errordlg('Argument must be a row vector','Input Argument Error!','modal');
       return
   end;
   for i=1:length(user_input)
       if user_input(i)<0
           errordlg('All elements must be positive','Input Argument Error!','modal');
           return
       end
   end 
   verified=1;
end



% --------------------------------------------------------------------
function File1_Callback(hObject, eventdata, handles)
% hObject    handle to File1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Exit1_Callback(hObject, eventdata, handles)
% hObject    handle to Exit1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close_Callback(handles.close, eventdata, handles);

% --------------------------------------------------------------------
function Options1_Callback(hObject, eventdata, handles)
% hObject    handle to Options1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.Designed==1
    set(handles.SignalPlot,'Enable','on');
    set(handles.DFTPlot,'Enable','on');
    set(handles.AutoCorrPlot,'Enable','on');
    set(handles.PowerPlot,'Enable','on');
    set(handles.AllPlot,'Enable','on');
else
    set(handles.SignalPlot,'Enable','off');
    set(handles.DFTPlot,'Enable','off');
    set(handles.AutoCorrPlot,'Enable','off');
    set(handles.PowerPlot,'Enable','off');
    set(handles.AllPlot,'Enable','off');
end

% --------------------------------------------------------------------
function SignalPlot_Callback(hObject, eventdata, handles)
% hObject    handle to SignalPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sequence_plot(handles.Signal,[1:handles.SignalLength+1])

% --------------------------------------------------------------------
function DFTPlot_Callback(hObject, eventdata, handles)
% hObject    handle to DFTPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
DFT_plot_multilev(handles.Signal,[1:handles.SignalLength],2)

% --------------------------------------------------------------------
function AutoCorrPlot_Callback(hObject, eventdata, handles)
% hObject    handle to AutoCorrPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
autocorrelation_plot(handles.Signal,[1:handles.SignalLength+1],2)

% --------------------------------------------------------------------
function PowerPlot_Callback(hObject, eventdata, handles)
% hObject    handle to PowerPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
power_plot(handles.Signal,[1:3*handles.SignalLength],2)

% --------------------------------------------------------------------
function AllPlot_Callback(hObject, eventdata, handles)
% hObject    handle to AllPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
sequence_plot(handles.Signal,[1:handles.SignalLength+1]);
DFT_plot_multilev(handles.Signal,[1:handles.SignalLength],1);
autocorrelation_plot(handles.Signal,[1:handles.SignalLength+1],1);
power_plot(handles.Signal,[1:3*handles.SignalLength],1)

% --------------------------------------------------------------------
function Help1_Callback(hObject, eventdata, handles)
% hObject    handle to Help1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function help_intro_Callback(hObject, eventdata, handles)
% hObject    handle to help_intro (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

helpwin help_introduction


% --------------------------------------------------------------------
function About_Callback(hObject, eventdata, handles)
% hObject    handle to About (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

help_about();




